const { Dropzone } = window;

/**
 * This module handles the integration of Dropzone
 */
export default () => {
	if (!Dropzone) {
		return;
	}

	document.querySelectorAll('#apply').forEach((item) => {
		console.log('init sg_jobs');
		addFileUpload(item, 'coverLetter');
	});

	function addFileUpload(item, uploadName) {
		const uploadBox = item.querySelector('.' + uploadName + '-upload');
		const uploadButton = item.querySelector('.' + uploadName + '-upload-button');

		console.log(item);
		console.log(uploadBox);
		console.log(uploadButton);

		if (!uploadBox || !uploadButton || !item) {
			return;
		}
		console.log('all elements found');
		const {
			maxFileAmount,
			validFileExtensions,
			maxFileSize,
			innerText,
			cancelUpload,
			removeFile,
			fileTypeError,
			uploadAjax
		} = uploadBox.dataset;

		console.log(uploadBox.dataset);
		console.log(uploadAjax);
		uploadBox.classList.add('dropzone');

		uploadButton.addEventListener('click', () => {
			uploadBox.classList.toggle('hidden');
		});

		const dropzone = new Dropzone('#apply .' + uploadName + '-upload', {
			url: uploadAjax,
			addRemoveLinks: true,
			paramName: 'files',
			dictDefaultMessage: innerText,
			maxFilesize: maxFileSize,
			maxFiles: maxFileAmount,
			acceptedFiles: validFileExtensions,
			dictInvalidFileType: fileTypeError,
			dictCancelUpload: cancelUpload,
			dictRemoveFile: removeFile,
		});
		dropzone.on('success', (file) => handleUpload(file, item, uploadName));
		dropzone.on('removedfile', (file) => handleRemoval(file, item, uploadName));
	}

	function handleUpload(file, item, uploadName) {
		const { uuid } = file.upload;
		const response = JSON.parse(file.xhr.response);

		item.insertAdjacentHTML(
			'beforeend',
			`<input data-uuid='${uuid}' type='hidden' name='${uploadName}[${uuid}][uuid]' value='${uuid}'>
			<input data-uuid='${uuid}' type='hidden' name='${uploadName}[${uuid}][path]' value='${response.path}'>`,
		);
	}

	function handleRemoval(file, item, uploadName) {
		const { uuid } = file.upload;
		item.querySelectorAll(`[data-uuid='${uuid}']`).forEach((item) => {
			item.remove();
		});
	}
};
